package jaugment2.worldclock;

import javax.swing.*;
import java.awt.*;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.Iterator;

import jaugment2.helpers.Logger;
import java.text.DateFormat;
import java.awt.event.*;

/**
 * Small dockin for the SwingUI showing a digital clock.
 */
public class WorldClockDockin extends JPanel
{
  JLabel jLabel1 = new JLabel();
  private static final boolean debug = false;

  DateFormat timeFormat = DateFormat.getTimeInstance();

  private WorldClockServiceProxy proxy = null;
  BorderLayout borderLayout1 = new BorderLayout();

  public WorldClockDockin(Object p)
  {
    if(debug) Logger.debug.println("DEBUG: [WorldClockDockin] param="+p);
    this.proxy = (WorldClockServiceProxy)p;
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  public void setFont(Font f)
  {
    if(f == null)
      return;
    if(jLabel1 == null)
      return;
    Font f2 = new Font(f.getFontName(), f.getStyle(), (int)(f.getSize()*0.75));
    super.setFont(f2);
    jLabel1.setFont(f2);
  }

  private void jbInit() throws Exception
  {
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel1.setText("00:00:00");
    this.setMaximumSize(new Dimension(109, 30));
    this.setMinimumSize(new Dimension(59, 19));
    this.setPreferredSize(new Dimension(89, 19));
    this.addMouseListener(new java.awt.event.MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
          this_mouseClicked(e);
        }
      });
    GridBagLayout gridbag = new GridBagLayout();
    this.setLayout(gridbag);
    GridBagConstraints c = new GridBagConstraints();
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;
    gridbag.setConstraints( jLabel1, c);
    this.add(jLabel1);
//    this.setLayout(borderLayout1);
//    this.add(jLabel1, BorderLayout.CENTER);
    go.setDaemon(true);
    go.start();
  }

  private static String conv(long n)
  {
    if(n==0)
      return("00");
    return( n<10?"0"+n:""+n);
  }

  private Thread go = new Thread()
  {
    public void run()
    {
      try
      {
        int counter = 0; // counter to not cause network-activity 2 times a second
        java.util.Set cities = null;
        java.util.HashMap timezones = new java.util.HashMap();
        while(true)
        {
          String text = "";
          Date time = new Date();
          if(counter==0)
          {
            counter=20;
            cities = proxy.cities();
          }
          counter--;

          jPopupMenu1.removeAll(); 

          for ( Iterator i = cities.iterator(); i.hasNext(); )
          {
            String city = (String)i.next();
            if(counter==19)
            {
              timezones.put(city, proxy.getTimeZone(city));
            }
            
            if(debug) Logger.debug.println("DEBUG: [WorldClockDockin] city="+city);
            timeFormat.setTimeZone( TimeZone.getTimeZone((String)timezones.get(city)));
            text += city+":"+timeFormat.format( time)+" ";
            jPopupMenu1.add(new JMenuItem(city+":"+timeFormat.format( time)));
          } // end of for ()

//          timeFormat.setTimeZone( TimeZone.getTimeZone("GMT"));
          if(debug) Logger.debug.println("DEBUG: [WorldClockDockin] text="+text);
          jLabel1.setText( text.trim());
          sleep(500);
        }
      }
      catch(Exception e)
      {
        e.printStackTrace(Logger.err);
      }
    };

    };
  JPopupMenu jPopupMenu1 = new JPopupMenu();

  void this_mouseClicked(MouseEvent e)
  {
    jPopupMenu1.show(this, e.getX(), e.getY());

      //TODO
  }
}
