package jaugment2.worldclock;

  //JDK
import java.rmi.server.UnicastRemoteObject;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.MarshalledObject;
import java.io.Serializable;
import java.lang.IllegalStateException;
import java.util.Enumeration;
import java.util.Map;
import java.util.Set;

  //JINI
import net.jini.core.event.RemoteEventListener;
import net.jini.core.lease.LeaseDeniedException;
import net.jini.core.lease.Lease;
import net.jini.admin.Administrable;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;
  //project
import jaugment2.jini.simpleService.simpleAdministrator;
import jaugment2.jini.simpleService.SimpleRepresentedAdministrator;
import jaugment2.directory.Directory.*;
import jaugment2.directory.DirectoryServiceSwingAdministration;

//helper-mark for configure to determine that rmic needs to be executed for this file
//rmimakehelper


public class WorldClockServiceProxy extends UnicastRemoteObject implements Administrable, Serializable, Remote
{

  private WorldClockService service;

  public WorldClockServiceProxy(WorldClockService s) throws RemoteException
  {
    super(0,
          ((System.getProperty("jaugment2.clock.WorldClockServiceProxy.useSSL")!=null)?
           new jaugment2.rmi.SSLRMIClientSocketFactory("jaugment2.clock.WorldClockServiceProxy.sslserveropts"):null
           ),
          ((System.getProperty("jaugment2.clock.WorldClockServiceProxy.useSSL")!=null)?
           new jaugment2.rmi.SSLRMIServerSocketFactory("jaugment2.clock.WorldClockServiceProxy.sslserveropts"):null
           )
          );

    this.service = s;
  }

    /**
     * Returns an object that implements our administration-interfaces.
     *
     * @throws java.rmi.RemoteException
     * @see JoinAdmin
     */
  public Object getAdmin() throws RemoteException
  {
//   return(new SimpleRepresentedAdministrator(service, new UIDescriptor[] {DirectoryServiceSwingAdministration.getUIDescriptor()}));
//   return(new DirectoryServiceAdministrator(service));
    return(new simpleAdministrator(service));
  }

/*
  public Map getCities()
  {
    return service.getCities();
  }
*/
  public Set cities()
  {
    return service.cities();
  }

  public String getTimeZone( String cityName)
  {
    return service.getTimeZone( cityName);
  }

}
