package jaugment2.worldclock;


  //Swing
import javax.swing.*;
import javax.swing.table.TableModel;
import javax.swing.event.TableModelListener;
import javax.swing.event.TableModelEvent;
import java.io.Serializable;
import java.io.IOException;
import java.rmi.MarshalledObject;
import java.rmi.RemoteException;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Set;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Map;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.ListIterator;
import java.awt.*;
import java.awt.event.*;

  //JINI
import net.jini.core.lookup.ServiceItem;
  //serviceui-draft-standart
import net.jini.lookup.entry.UIDescriptor;
import net.jini.lookup.ui.MainUI;
import net.jini.lookup.ui.factory.JComponentFactory;
import net.jini.lookup.ui.attribute.UIFactoryTypes;
import net.jini.lookup.ui.attribute.RequiredPackages;
  //project
import jaugment2.helpers.Logger;


public class WorldClockServiceRepresentation
{

  private static final boolean debugMessages = false;


    /**
     * Get a UIDescriptor as needed by the serviceui-draft-standart
     */
  public static UIDescriptor getUIDescriptor()
  {
    try
    {
      return(new UIDescriptor(MainUI.ROLE,
                              JComponentFactory.TOOLKIT,
                              getServiceUIProperties(),
                              new MarshalledObject(new Factory()))
        );
    }
    catch(IOException e)
    {
      Logger.err.print(e.getLocalizedMessage());
      e.printStackTrace(Logger.err);
    }
    return(null);
  }

    /**
     * Gets a serviceui-draft-standart-compactible attribute-set of this representation
     */
  static Set getServiceUIProperties()
  {
    HashSet set = new HashSet();
    set.add("javax.swing.JComponent");
    set.add("javax.swing.JPanel");
    set.add("java.awt.Component");

    HashSet retval = new HashSet();
    retval.add(new UIFactoryTypes(set));

    HashMap map = new HashMap();
    map.put("javax.swing", Package.getPackage("javax.swing").getSpecificationVersion());
    RequiredPackages req = new RequiredPackages(map);
    retval.add(req);

    return(retval);
  }


    /**
     * A serializable factory for creating this UI
     */
  public static class Factory implements JComponentFactory, Serializable
  {

      /**
       * Returns a <CODE>JComponent</CODE>.
       */
    public JComponent getJComponent(Object roleObject)
    {
      if(debugMessages)Logger.debug.println("DEBUG: [WorldClockServiceRepresentation.factory] getJComponent called");
      try
      {
        WorldClockDockin rep = new WorldClockDockin( (WorldClockServiceProxy)((ServiceItem)roleObject).service );
        return(rep);
      }
      catch(Exception e)
      {
        e.printStackTrace(Logger.err);
      }
/*    catch(RemoteException ex)
      {
      ex.printStackTrace(Logger.err);
      return(null);
      }*/
      return(null);

    }
  }



}
